# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.3'

from Globals import HTML,HTMLFile,MessageDialog
from ImageFile import ImageFile  
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument
from OFS.DTMLMethod import decapitate
from AccessControl import getSecurityManager


import urllib,socket,httplib
import os,stat,string,posixfile
import sys, traceback, string


manage_add_doc_Form = HTMLFile('dtml/add_doc_form', globals())
default_jsp_doc="""<dtml-var standard_html_header>
<h1><dtml-var title_and_id></h1>
<%
  out.println("Hello World!");
%>
<dtml-var standard_html_footer>"""



def manage_add_doc(self, id='',title='', REQUEST=None, submit=None):
    """Add a Zope Jsp Document """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_doc_form',)
    #create new object instance
    id=str(id)
    if id[-4:]!='.jsp': id=id+'.jsp'
    ob=ZopeJspDocument(default_jsp_doc, __name__=id)
    ob.own_path="x" #system full path to hard disk such as d:/Tom/webapps/ROOT/Zope/subfolder/file.jsp
    ob.port=""      #8144 - the local jsp server port
    ob.folder=""    #subfolder on jsp server root  : Zope
    ob.web_path=""  #web path : subfolder/file.jsp
    ob.compiled=0   #set to 1 when a success java compile call and 0 when save a new version
    ob.updated=0    #set to 1 when JspFolder update zope->jsp folder
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'








class ZopeJspDocument(DTMLDocument):
    """ Zope Product object."""    

    meta_type = 'Jsp Document'
    icon = 'misc_/ZopeJsp/docicon'     

    manage_opt = HTMLFile('dtml/manage_doc_options', globals())


    _properties=(
{'id':'title', 'type':'string','mode':'w'},
)


    

    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
        """ call jsp server and return result """
        if self.compiled==0:
            if hasattr(self, 'aq_explicit'): bself=self.aq_explicit
            else: bself=self

            security=getSecurityManager()
            security.addContext(self)
            try:
                if client is None:
                    #you called this document like <dtml-var document>
                    r=apply(HTML.__call__, (self, bself, REQUEST), kw)
                    if not self._cache_namespace_keys:
                        self.ZCacheable_set(r)
                else:
                    #called by web (by URL)
                    r=apply(HTML.__call__, (self, (client, bself), REQUEST), kw)
               
                f=posixfile.open(self.own_path,"w")
                f.write(r)
                f.close()
                self.updated=1

            finally:
                  security.removeContext(self)
            
            
            
        try:
            h = httplib.HTTP("localhost:%s" % (self.port,))
            #h.set_debuglevel(1)
            
            #build QUERY_STRING and send it by GET or POST
            QUERY_STRING=urllib.urlencode(REQUEST.form)
            
            #use GET or POST
            #POST is not working!
            h.putrequest('GET', '/%s/%s?%s' % (self.folder,self.web_path,QUERY_STRING))
            #h.putrequest('POST','/%s/%s' % (self.folder,self.web_path))
            h.putheader('Accept', 'text/html')
            h.putheader('Accept', 'text/plain')
            
            #send cookie headers for jsp context     (Zope -> jsp)
            for i in REQUEST.cookies.items():
                h.putheader("Cookie",i[0]+'='+i[1])
            h.endheaders()
            #send POST data
            #h.send(QUERY_STRING) #comment this line when using GET
            errcode, errmsg, headers = h.getreply()
            if errcode==200:
                if self.compiled==0:
                    self.compiled=1 #mark compiled if success
            
            #set all headers for Zope    (jsp -> Zope)
            decapitate(str(headers)+'\n\n', RESPONSE)

            f = h.getfile()
            data = f.read() # Get the raw HTML
            f.close()
        except:
            type, val, tb = sys.exc_info()
            data="""
<html>
<body bgcolor="eeeeff">
<font color="red">
An error occured!<br>
To fix problem:
<ol>
<li>Use this document inside of a 'Jsp Folder'.
<li>On that 'Jsp Folder' use the tab 'Update' to rebuild the jsp site on hard disk
<li>If you already done that look to the below error message
</ol>
</font>
<hr>
<pre>
%s
</pre>
</body>
</html>
""" % (string.join(traceback.format_exception(type, val, tb), ''),)
            del type, val, tb

        return data
    


    def manage_upload(self,file='', REQUEST=None):
        """ called when upload from zope web interface"""
        ret = DTMLDocument.manage_upload(self,file,REQUEST)
        self.compiled=0
        self.updated=0
        return ret
    

    def PUT(self, REQUEST, RESPONSE):
        """ PUT method - called when webdav * ftp PUT """
        DTMLDocument.PUT(self,REQUEST, RESPONSE)
        self.compiled=0
        self.updated=0
        return RESPONSE


    def manage_edit(self,data,title,SUBMIT='Change',dtpref_cols='50',
                    dtpref_rows='20',REQUEST=None):
        """
        Replaces a JSP Documents contents with Data, Title with Title.
        called from zope web interface
        """
        
        ret = DTMLDocument.manage_edit(self,data,title,SUBMIT,dtpref_cols,dtpref_rows,REQUEST)
        self.compiled=0 #not compiled to .class
        self.updated=0  #not saved on jsp server root as regular file
        #the __call__ method will do it later (save & compile)
        return ret




Globals.default__class_init__(ZopeJspDocument)


