# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================

__version__= '1.3'

from Globals import HTML,HTMLFile,MessageDialog
from ImageFile import ImageFile  

import Globals, sys, traceback

from OFS.Folder import Folder
import os,stat,string,posixfile


import sys, traceback, string





manage_add_folder_Form = HTMLFile('dtml/add_folder_form', globals())
def manage_add_folder(self, id='',title='',jsp_server_root='',jsp_server_port='',zope_jsp_server_folder='', REQUEST=None, submit=None):
    """Add a Zope Jsp Folder """
    if id=='':
        return MessageDialog( title='Error', message='Please enter an id!', action = REQUEST['URL1']+'/add_folder_form',)
    #create new object instance
    ob=ZopeJspFolder(id,title,jsp_server_root,jsp_server_port,zope_jsp_server_folder)
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit=="Add": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return 'Nothing'





class ZopeJspFolder(Folder):
    """ Zope Product object."""    

    meta_type = 'Jsp Folder'
    icon = 'misc_/ZopeJsp/foldericon'     

    manage_opt = HTMLFile('dtml/manage_folder_options', globals())

    manage_options= Folder.manage_options + (
          
        {'label':'Update','action':'manage_opt'},
        
    ) 
                  


    _properties=(
{'id':'title', 'type':'string','mode':'w'},
{'id':'jsp_server_root', 'type':'string'},
)


    


    def __init__(self,id,title,jsp_server_root,jsp_server_port,zope_jsp_server_folder):
        """ init method """
        self.id=id
        self.title=title
        self.jsp_server_root=jsp_server_root
        self.jsp_server_port=jsp_server_port
        self.zope_jsp_server_folder=zope_jsp_server_folder



    def manage_opt_action(self,title='',jsp_server_root='',jsp_server_port='',zope_jsp_server_folder='',REQUEST=None):
        """ update options """
        self.title=title
        self.jsp_server_root=jsp_server_root
        if self.jsp_server_root[-1:] in ['/','\\']:
            self.jsp_server_root=self.jsp_server_root[:-1]
        self.jsp_server_port=jsp_server_port
        self.zope_jsp_server_folder=zope_jsp_server_folder
        self.empty_folder(jsp_server_root+'/'+self.zope_jsp_server_folder)
        self.rebuild(self,REQUEST) #rebuild from folder=self (current Zope folder)
        if REQUEST is not None:
            return Globals.MessageDialog( title='Edited', message='<strong>%s</strong> has been edited.' % self.id, action ='manage_opt',)
 

    def empty_folder(self,dir='',REQUEST=None):
        """ recursive erase a folder """
        if REQUEST is not None:
            return "Sorry! You can't do it over the web!"
        for f in os.listdir(dir):
            pathname = '%s/%s' % (dir,f)
            mode = os.stat(pathname)[stat.ST_MODE]
            if stat.S_ISDIR(mode):
                self.empty_folder(pathname)
                os.rmdir(pathname)
            elif stat.S_ISREG(mode):
                os.remove(pathname)
                
        


    def rebuild(self,folder='',REQUEST=None):
        """ update jsp folder """
        #if REQUEST is not None:
        #    return "Sorry! You can't do it over the web!"
        L=folder.objectItems(['Folder','Jsp Document','DTML Document','DTML Method','File'])
        for i in L:
            id=i[0]
            ob=i[1]
            #recursive call
            if ob.getNodeName() == 'Folder' : self.rebuild(ob,REQUEST)
            else:
                x=1+len(self.absolute_url())
                s=ob.absolute_url()
                ob_path=self.jsp_server_root+'/'+self.zope_jsp_server_folder+'/'+s[x:]
                ob.own_path=ob_path
                L=string.split(ob_path,'/')
                dir=string.join(L[:-1],'/')
                try: os.makedirs(dir)
                except: pass
                ob.own_path=ob_path
                ob.port=self.jsp_server_port
                ob.folder=self.zope_jsp_server_folder
                ob.web_path=s[x:]
                try:
                        f=posixfile.open(ob_path,"w")
                        if ob.getNodeName() == 'File': r=ob.data
                        #elif ob.getNodeName() == 'Image': r=str(ob.data)
                        else:
                            r=apply(HTML.__call__, (ob, ob, REQUEST), {})
                        f.write(r)
                        if ob.getNodeName=='ZopeJspDocument':
                            ob.updated=1  #set updated flag to 1 which means jsp_document need to be rendered on call time
                            print ob.absolute_url()
                        f.close()
                except:
                       print "JspFolder: error saving id=",ob.absolute_url()
                       print "NodeName=",ob.getNodeName()
                       type, val, tb = sys.exc_info()
                       print(string.join(traceback.format_exception(type, val, tb), ''))
                       del type, val, tb




            


Globals.default__class_init__(ZopeJspFolder)


