# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
# ======================================================================
__version__= '1.2'


from Globals import HTMLFile,MessageDialog
from ImageFile import ImageFile
from ZopeJspFolder import ZopeJspFolder,manage_add_folder_Form,manage_add_folder
from ZopeJspDocument import ZopeJspDocument,manage_add_doc_Form,manage_add_doc





# Load images from disk and make them accessible
misc_={
    'foldericon': ImageFile('img/foldericon.gif',globals()),
    'docicon':    ImageFile('img/documenticon.gif',globals()),
      }  








def initialize(context): 
    """Initialize the product."""
    
    try: 
        context.registerClass(
            ZopeJspFolder,
            constructors = (                 
                manage_add_folder_Form,  #html file; html-form has action next constructor
                manage_add_folder),     #constructor caled from html-form (action)                                            
            )
        context.registerBaseClass(ZopeJspFolder)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb

    #context.registerHelp()
    #context.registerHelpTitle('ZopeJspFolder Help')


    try: 
        context.registerClass(
            ZopeJspDocument,
            constructors = (                 
                manage_add_doc_Form,  #html file; html-form has action next constructor
                manage_add_doc),     #constructor caled from html-form (action)                                            
            )
        context.registerBaseClass(ZopeJspDocument)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb

    #context.registerHelp()
    #context.registerHelpTitle('ZopeJspDocument Help')

